diff --git a/gnome-session/gsm-manager.c b/gnome-session/gsm-manager.c
index b7f1788e..743a372e 100644
--- a/gnome-session/gsm-manager.c
+++ b/gnome-session/gsm-manager.c
@@ -44,62 +44,108 @@
 
 #include <systemd/sd-daemon.h>
 
-#include "gsm-app.h"
-#include "gsm-client.h"
+#include "gsm-store.h"
 #include "gsm-inhibitor.h"
 #include "gsm-presence.h"
 #include "gsm-shell.h"
-#include "gsm-store.h"
-#include "gsm-system.h"
+
+#include "gsm-dbus-client.h"
+
+#include "gsm-autostart-app.h"
+
 #include "gsm-util.h"
+#include "gsm-icon-names.h"
+#include "gsm-system.h"
+#include "gsm-shell-extensions.h"
+#include "gsm-fail-whale.h"
+
+/* UUIDs for log messages */
+#define GSM_MANAGER_STARTUP_SUCCEEDED_MSGID     "0ce153587afa4095832d233c17a88001"
+#define GSM_MANAGER_UNRECOVERABLE_FAILURE_MSGID "10dd2dc188b54a5e98970f56499d1f73"
 
 #define GSM_MANAGER_DBUS_PATH "/org/gnome/SessionManager"
 #define GSM_MANAGER_DBUS_NAME "org.gnome.SessionManager"
 #define GSM_MANAGER_DBUS_IFACE "org.gnome.SessionManager"
 
+/* Probably about the longest amount of time someone could reasonably
+ * want to wait, at least for something happening more than once.
+ * We can get deployed on very slow media though like CDROM devices,
+ * often with complex stacking/compressing filesystems on top, which
+ * is not a recipie for speed.   Particularly now that we throw up
+ * a fail whale if required components don't show up quickly enough,
+ * let's make this fairly long.
+ */
+#define GSM_MANAGER_PHASE_TIMEOUT 90 /* seconds */
+
+#define GDM_FLEXISERVER_COMMAND "gdmflexiserver"
+#define GDM_FLEXISERVER_ARGS    "--startnew Standard"
+
 #define SESSION_SCHEMA            "org.gnome.desktop.session"
 #define KEY_IDLE_DELAY            "idle-delay"
+#define KEY_SESSION_NAME          "session-name"
 
 #define GSM_MANAGER_SCHEMA        "org.gnome.SessionManager"
 #define KEY_LOGOUT_PROMPT         "logout-prompt"
+#define KEY_SHOW_FALLBACK_WARNING "show-fallback-warning"
+
+#define SCREENSAVER_SCHEMA        "org.gnome.desktop.screensaver"
+#define KEY_SLEEP_LOCK            "lock-enabled"
 
 #define LOCKDOWN_SCHEMA           "org.gnome.desktop.lockdown"
 #define KEY_DISABLE_LOG_OUT       "disable-log-out"
 #define KEY_DISABLE_USER_SWITCHING "disable-user-switching"
 
+static void app_registered (GsmApp     *app, GParamSpec *spec, GsmManager *manager);
+
 typedef enum
 {
         GSM_MANAGER_LOGOUT_NONE,
         GSM_MANAGER_LOGOUT_LOGOUT,
         GSM_MANAGER_LOGOUT_REBOOT,
+        GSM_MANAGER_LOGOUT_REBOOT_INTERACT,
         GSM_MANAGER_LOGOUT_SHUTDOWN,
+        GSM_MANAGER_LOGOUT_SHUTDOWN_INTERACT,
 } GsmManagerLogoutType;
 
-struct _GsmManager
+typedef struct
 {
-        GObject                 parent;
-
+        gboolean                failsafe;
+        gboolean                systemd_managed;
         gboolean                systemd_initialized;
+        gboolean                manager_initialized;
         GsmStore               *clients;
         GsmStore               *inhibitors;
         GsmInhibitorFlag        inhibited_actions;
         GsmStore               *apps;
         GsmPresence            *presence;
         char                   *session_name;
+        gboolean                is_fallback_session : 1;
 
         /* Current status */
         GsmManagerPhase         phase;
         guint                   phase_timeout_id;
+        GSList                 *required_apps;
+        GSList                 *pending_apps;
         GsmManagerLogoutMode    logout_mode;
         GSList                 *query_clients;
+        guint                   query_timeout_id;
+        /* This is used for GSM_MANAGER_PHASE_END_SESSION only at the moment,
+         * since it uses a sublist of all running client that replied in a
+         * specific way */
+        GSList                 *next_query_clients;
         /* This is the action that will be done just before we exit */
         GsmManagerLogoutType    logout_type;
 
+        /* List of clients which were disconnected due to disabled condition
+         * and shouldn't be automatically restarted */
+        GSList                 *condition_clients;
+
         GSList                 *pending_end_session_tasks;
         GCancellable           *end_session_cancellable;
 
         GSettings              *settings;
         GSettings              *session_settings;
+        GSettings              *screensaver_settings;
         GSettings              *lockdown_settings;
 
         GsmSystem              *system;
@@ -108,33 +154,45 @@ struct _GsmManager
         gboolean                dbus_disconnected : 1;
 
         GsmShell               *shell;
-        gulong                  shell_end_session_dialog_canceled_id;
-        gulong                  shell_end_session_dialog_open_failed_id;
-        gulong                  shell_end_session_dialog_confirmed_logout_id;
-        gulong                  shell_end_session_dialog_confirmed_shutdown_id;
-        gulong                  shell_end_session_dialog_confirmed_reboot_id;
-};
+        guint                   shell_end_session_dialog_canceled_id;
+        guint                   shell_end_session_dialog_open_failed_id;
+        guint                   shell_end_session_dialog_confirmed_logout_id;
+        guint                   shell_end_session_dialog_confirmed_shutdown_id;
+        guint                   shell_end_session_dialog_confirmed_reboot_id;
+} GsmManagerPrivate;
 
 enum {
         PROP_0,
+        PROP_CLIENT_STORE,
         PROP_SESSION_NAME,
+        PROP_FALLBACK,
+        PROP_FAILSAFE,
+        PROP_SYSTEMD_MANAGED
 };
 
+enum {
+        PHASE_CHANGED,
+        LAST_SIGNAL
+};
+
+static guint signals [LAST_SIGNAL] = { 0 };
+
 static void     gsm_manager_class_init  (GsmManagerClass *klass);
 static void     gsm_manager_init        (GsmManager      *manager);
 
 static gboolean _log_out_is_locked_down     (GsmManager *manager);
 
-static void     on_client_end_session_response (GsmClient  *client,
-                                                gboolean    is_ok,
-                                                const char *reason,
-                                                GsmManager *manager);
-
+static void     _handle_client_end_session_response (GsmManager *manager,
+                                                     GsmClient  *client,
+                                                     gboolean    is_ok,
+                                                     gboolean    do_last,
+                                                     gboolean    cancel,
+                                                     const char *reason);
 static void     show_shell_end_session_dialog (GsmManager                   *manager,
                                                GsmShellEndSessionDialogType  type);
 static gpointer manager_object = NULL;
 
-G_DEFINE_TYPE (GsmManager, gsm_manager, G_TYPE_OBJECT)
+G_DEFINE_TYPE_WITH_PRIVATE (GsmManager, gsm_manager, G_TYPE_OBJECT)
 
 static const GDBusErrorEntry gsm_manager_error_entries[] = {
         { GSM_MANAGER_ERROR_GENERAL, GSM_MANAGER_DBUS_IFACE ".GeneralError" },
@@ -165,7 +223,7 @@ start_app_or_warn (GsmManager *manager,
         gboolean res;
         GError *error = NULL;
 
-        g_debug ("GsmManager: starting app '%s'", gsm_app_peek_app_id (app));
+        g_debug ("GsmManager: starting app '%s'", gsm_app_peek_id (app));
 
         res = gsm_app_start (app, &error);
         if (error != NULL) {
@@ -175,6 +233,75 @@ start_app_or_warn (GsmManager *manager,
         return res;
 }
 
+static gboolean
+is_app_required (GsmManager *manager,
+                 GsmApp     *app)
+{
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
+        return g_slist_find (priv->required_apps, app) != NULL;
+}
+
+static void
+on_required_app_failure (GsmManager  *manager,
+                         GsmApp      *app)
+{
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+        const gchar *app_id;
+        gboolean allow_logout;
+        GsmShellExtensions *extensions;
+
+        app_id = gsm_app_peek_app_id (app);
+
+        if (g_str_equal (app_id, "org.gnome.Shell.desktop")) {
+                extensions = g_object_new (GSM_TYPE_SHELL_EXTENSIONS, NULL);
+                gsm_shell_extensions_disable_all (extensions);
+        } else {
+                extensions = NULL;
+        }
+
+        if (gsm_system_is_login_session (priv->system)) {
+                allow_logout = FALSE;
+        } else {
+                allow_logout = !_log_out_is_locked_down (manager);
+        }
+
+        sd_journal_send ("MESSAGE_ID=%s", GSM_MANAGER_UNRECOVERABLE_FAILURE_MSGID,
+                         "PRIORITY=%d", 3,
+                         "MESSAGE=Unrecoverable failure in required component %s", app_id,
+                         NULL);
+
+        gsm_fail_whale_dialog_we_failed (FALSE,
+                                         allow_logout,
+                                         extensions);
+}
+
+static void
+on_display_server_failure (GsmManager *manager,
+                           GsmApp     *app)
+{
+        const gchar *app_id;
+        GsmShellExtensions *extensions;
+
+        app_id = gsm_app_peek_app_id (app);
+
+        if (g_str_equal (app_id, "org.gnome.Shell.desktop")) {
+                extensions = g_object_new (GSM_TYPE_SHELL_EXTENSIONS, NULL);
+                gsm_shell_extensions_disable_all (extensions);
+
+                g_object_unref (extensions);
+        } else {
+                extensions = NULL;
+        }
+
+        sd_journal_send ("MESSAGE_ID=%s", GSM_MANAGER_UNRECOVERABLE_FAILURE_MSGID,
+                         "PRIORITY=%d", 3,
+                         "MESSAGE=Unrecoverable failure in required component %s", app_id,
+                         NULL);
+
+        gsm_quit ();
+}
+
 static gboolean
 _debug_client (const char *id,
                GsmClient  *client,
@@ -187,7 +314,9 @@ _debug_client (const char *id,
 static void
 debug_clients (GsmManager *manager)
 {
-        gsm_store_foreach (manager->clients,
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
+        gsm_store_foreach (priv->clients,
                            (GsmStoreFunc)_debug_client,
                            manager);
 }
@@ -204,25 +333,129 @@ _find_by_cookie (const char   *id,
         return (*cookie_ap == cookie_b);
 }
 
+static gboolean
+_client_has_startup_id (const char *id,
+                        GsmClient  *client,
+                        const char *startup_id_a)
+{
+        const char *startup_id_b;
+
+        startup_id_b = gsm_client_peek_startup_id (client);
+        if (IS_STRING_EMPTY (startup_id_b)) {
+                return FALSE;
+        }
+
+        return (strcmp (startup_id_a, startup_id_b) == 0);
+}
+
+static void
+app_condition_changed (GsmApp     *app,
+                       gboolean    condition,
+                       GsmManager *manager)
+{
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+        GsmClient *client;
+
+        g_debug ("GsmManager: app:%s condition changed condition:%d",
+                 gsm_app_peek_id (app),
+                 condition);
+
+        client = (GsmClient *)gsm_store_find (priv->clients,
+                                              (GsmStoreFunc)_client_has_startup_id,
+                                              (char *)gsm_app_peek_startup_id (app));
+
+        if (condition) {
+                if (!gsm_app_is_running (app) && client == NULL) {
+                        start_app_or_warn (manager, app);
+                } else {
+                        g_debug ("GsmManager: not starting - app still running '%s'", gsm_app_peek_id (app));
+                }
+        } else {
+                GError  *error;
+                gboolean res;
+
+                if (client != NULL) {
+                        /* Kill client in case condition if false and make sure it won't
+                         * be automatically restarted by adding the client to
+                         * condition_clients */
+                        priv->condition_clients =
+                                g_slist_prepend (priv->condition_clients, client);
+
+                        g_debug ("GsmManager: stopping client %s for app", gsm_client_peek_id (client));
+
+                        error = NULL;
+                        res = gsm_client_stop (client, &error);
+                        if (! res) {
+                                g_warning ("Not able to stop app client from its condition: %s",
+                                           error->message);
+                                g_error_free (error);
+                        }
+                } else {
+                        g_debug ("GsmManager: stopping app %s", gsm_app_peek_id (app));
+
+                        /* If we don't have a client then we should try to kill the app */
+                        error = NULL;
+                        res = gsm_app_stop (app, &error);
+                        if (! res) {
+                                g_warning ("Not able to stop app from its condition: %s",
+                                           error->message);
+                                g_error_free (error);
+                        }
+                }
+        }
+}
+
 static const char *
 phase_num_to_name (guint phase)
 {
+        const char *name;
+
         switch (phase) {
+        case GSM_MANAGER_PHASE_STARTUP:
+                name = "STARTUP";
+                break;
+        case GSM_MANAGER_PHASE_EARLY_INITIALIZATION:
+                name = "EARLY_INITIALIZATION";
+                break;
+        case GSM_MANAGER_PHASE_PRE_DISPLAY_SERVER:
+                name = "PRE_DISPLAY_SERVER";
+                break;
+        case GSM_MANAGER_PHASE_DISPLAY_SERVER:
+                name = "DISPLAY_SERVER";
+                break;
         case GSM_MANAGER_PHASE_INITIALIZATION:
-                return "INITIALIZATION";
+                name = "INITIALIZATION";
+                break;
+        case GSM_MANAGER_PHASE_WINDOW_MANAGER:
+                name = "WINDOW_MANAGER";
+                break;
+        case GSM_MANAGER_PHASE_PANEL:
+                name = "PANEL";
+                break;
+        case GSM_MANAGER_PHASE_DESKTOP:
+                name = "DESKTOP";
+                break;
         case GSM_MANAGER_PHASE_APPLICATION:
-                return "APPLICATION";
+                name = "APPLICATION";
+                break;
         case GSM_MANAGER_PHASE_RUNNING:
-                return "RUNNING";
+                name = "RUNNING";
+                break;
         case GSM_MANAGER_PHASE_QUERY_END_SESSION:
-                return "QUERY_END_SESSION";
+                name = "QUERY_END_SESSION";
+                break;
         case GSM_MANAGER_PHASE_END_SESSION:
-                return "END_SESSION";
+                name = "END_SESSION";
+                break;
         case GSM_MANAGER_PHASE_EXIT:
-                return "EXIT";
+                name = "EXIT";
+                break;
         default:
                 g_assert_not_reached ();
+                break;
         }
+
+        return name;
 }
 
 static void start_phase (GsmManager *manager);
@@ -230,17 +463,24 @@ static void start_phase (GsmManager *manager);
 static void
 gsm_manager_quit (GsmManager *manager)
 {
-        switch (manager->logout_type) {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
+        /* See the comment in request_reboot() for some more details about how
+         * this works. */
+
+        switch (priv->logout_type) {
         case GSM_MANAGER_LOGOUT_LOGOUT:
         case GSM_MANAGER_LOGOUT_NONE:
                 gsm_quit ();
                 break;
         case GSM_MANAGER_LOGOUT_REBOOT:
-                gsm_system_complete_shutdown (manager->system);
+        case GSM_MANAGER_LOGOUT_REBOOT_INTERACT:
+                gsm_system_complete_shutdown (priv->system);
                 gsm_quit ();
                 break;
         case GSM_MANAGER_LOGOUT_SHUTDOWN:
-                gsm_system_complete_shutdown (manager->system);
+        case GSM_MANAGER_LOGOUT_SHUTDOWN_INTERACT:
+                gsm_system_complete_shutdown (priv->system);
                 gsm_quit ();
                 break;
         default:
@@ -254,18 +494,47 @@ static gboolean do_query_end_session_exit (GsmManager *manager);
 static void
 end_phase (GsmManager *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
         gboolean start_next_phase = TRUE;
 
         g_debug ("GsmManager: ending phase %s",
-                 phase_num_to_name (manager->phase));
+                 phase_num_to_name (priv->phase));
 
-        g_slist_free (manager->query_clients);
-        manager->query_clients = NULL;
+        g_slist_free (priv->pending_apps);
+        priv->pending_apps = NULL;
 
-        g_clear_handle_id (&manager->phase_timeout_id, g_source_remove);
+        g_slist_free (priv->query_clients);
+        priv->query_clients = NULL;
 
-        switch (manager->phase) {
+        g_slist_free (priv->next_query_clients);
+        priv->next_query_clients = NULL;
+
+        if (priv->query_timeout_id > 0) {
+                g_source_remove (priv->query_timeout_id);
+                priv->query_timeout_id = 0;
+        }
+        if (priv->phase_timeout_id > 0) {
+                g_source_remove (priv->phase_timeout_id);
+                priv->phase_timeout_id = 0;
+        }
+
+        switch (priv->phase) {
+        case GSM_MANAGER_PHASE_STARTUP:
+        case GSM_MANAGER_PHASE_EARLY_INITIALIZATION:
+        case GSM_MANAGER_PHASE_PRE_DISPLAY_SERVER:
+        case GSM_MANAGER_PHASE_DISPLAY_SERVER:
+                break;
         case GSM_MANAGER_PHASE_INITIALIZATION:
+                priv->manager_initialized = TRUE;
+                /* Wait for systemd if it isn't initialized yet*/
+                if (priv->systemd_managed && !priv->systemd_initialized) {
+                        sd_notify (0, "STATUS=GNOME Session Manager waiting for gnome-session-initialized.target (via signal)");
+                        start_next_phase = FALSE;
+                }
+                break;
+        case GSM_MANAGER_PHASE_WINDOW_MANAGER:
+        case GSM_MANAGER_PHASE_PANEL:
+        case GSM_MANAGER_PHASE_DESKTOP:
         case GSM_MANAGER_PHASE_APPLICATION:
                 break;
         case GSM_MANAGER_PHASE_RUNNING:
@@ -290,17 +559,199 @@ end_phase (GsmManager *manager)
         }
 
         if (start_next_phase) {
-                manager->phase++;
+                priv->phase++;
                 start_phase (manager);
         }
 }
 
+static void
+app_event_during_startup (GsmManager *manager,
+                          GsmApp     *app)
+{
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
+        if (!(priv->phase < GSM_MANAGER_PHASE_APPLICATION))
+                return;
+
+        priv->pending_apps = g_slist_remove (priv->pending_apps, app);
+
+        if (priv->pending_apps == NULL) {
+                if (priv->phase_timeout_id > 0) {
+                        g_source_remove (priv->phase_timeout_id);
+                        priv->phase_timeout_id = 0;
+                }
+
+                end_phase (manager);
+        }
+}
+
+static gboolean
+is_app_display_server (GsmManager *manager,
+                       GsmApp     *app)
+{
+        GsmManagerPhase phase;
+
+        /* Apps can only really act as a display server if
+         * we're a wayland session.
+         */
+        if (g_strcmp0 (g_getenv ("XDG_SESSION_TYPE"), "wayland") != 0)
+                return FALSE;
+
+        phase = gsm_app_peek_phase (app);
+
+        return (phase == GSM_MANAGER_PHASE_DISPLAY_SERVER &&
+                is_app_required (manager, app));
+}
+
+static void
+_restart_app (GsmManager *manager,
+              GsmApp     *app)
+{
+        GError *error = NULL;
+
+        if (is_app_display_server (manager, app)) {
+                on_display_server_failure (manager, app);
+                return;
+        }
+
+        if (!gsm_app_restart (app, &error)) {
+                if (is_app_required (manager, app)) {
+                        on_required_app_failure (manager, app);
+                } else {
+                        g_warning ("Error on restarting session managed app: %s", error->message);
+                }
+                g_clear_error (&error);
+
+                app_event_during_startup (manager, app);
+        }
+}
+
+static void
+app_died (GsmApp     *app,
+          int         signal,
+          GsmManager *manager)
+{
+        g_warning ("Application '%s' killed by signal %d", gsm_app_peek_app_id (app), signal);
+
+        if (gsm_app_get_registered (app) && gsm_app_peek_autorestart (app)) {
+                g_debug ("Component '%s' is autorestart, ignoring died signal",
+                         gsm_app_peek_app_id (app));
+                return;
+        }
+
+        _restart_app (manager, app);
+
+        /* For now, we don't do anything with crashes from
+         * non-required apps after they hit the restart limit.
+         *
+         * Note that both required and not-required apps will be
+         * caught by ABRT/apport type infrastructure, and it'd be
+         * better to pick up the crash from there and do something
+         * un-intrusive about it generically.
+         */
+}
+
+static void
+app_exited (GsmApp     *app,
+            guchar      exit_code,
+            GsmManager *manager)
+{
+        if (exit_code != 0)
+                g_warning ("App '%s' exited with code %d", gsm_app_peek_app_id (app), exit_code);
+        else
+                g_debug ("App %s exited successfully", gsm_app_peek_app_id (app));
+
+        /* Consider that non-success exit status means "crash" for required components */
+        if (exit_code != 0 && is_app_required (manager, app)) {
+                if (gsm_app_get_registered (app) && gsm_app_peek_autorestart (app)) {
+                        g_debug ("Component '%s' is autorestart, ignoring non-successful exit",
+                                 gsm_app_peek_app_id (app));
+                        return;
+                }
+
+                _restart_app (manager, app);
+        } else {
+                app_event_during_startup (manager, app);
+        }
+}
+
+static void
+app_registered (GsmApp     *app,
+                GParamSpec *spec,
+                GsmManager *manager)
+{
+        if (!gsm_app_get_registered (app)) {
+                return;
+        }
+
+        g_debug ("App %s registered", gsm_app_peek_app_id (app));
+
+        app_event_during_startup (manager, app);
+}
+
+static gboolean
+on_phase_timeout (GsmManager *manager)
+{
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+        GSList *a;
+
+        priv->phase_timeout_id = 0;
+
+        switch (priv->phase) {
+        case GSM_MANAGER_PHASE_STARTUP:
+        case GSM_MANAGER_PHASE_EARLY_INITIALIZATION:
+        case GSM_MANAGER_PHASE_PRE_DISPLAY_SERVER:
+        case GSM_MANAGER_PHASE_DISPLAY_SERVER:
+        case GSM_MANAGER_PHASE_INITIALIZATION:
+        case GSM_MANAGER_PHASE_WINDOW_MANAGER:
+        case GSM_MANAGER_PHASE_PANEL:
+        case GSM_MANAGER_PHASE_DESKTOP:
+        case GSM_MANAGER_PHASE_APPLICATION:
+                for (a = priv->pending_apps; a; a = a->next) {
+                        GsmApp *app = a->data;
+                        g_warning ("Application '%s' failed to register before timeout",
+                                   gsm_app_peek_app_id (app));
+                        if (is_app_required (manager, app))
+                                on_required_app_failure (manager, app);
+                }
+                break;
+        case GSM_MANAGER_PHASE_RUNNING:
+                break;
+        case GSM_MANAGER_PHASE_QUERY_END_SESSION:
+        case GSM_MANAGER_PHASE_END_SESSION:
+                break;
+        case GSM_MANAGER_PHASE_EXIT:
+                break;
+        default:
+                g_assert_not_reached ();
+                break;
+        }
+
+        end_phase (manager);
+
+        return FALSE;
+}
+
 static gboolean
 _start_app (const char *id,
             GsmApp     *app,
             GsmManager *manager)
 {
-        if (gsm_app_peek_is_disabled (app)) {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
+        if (gsm_app_peek_phase (app) != priv->phase) {
+                goto out;
+        }
+
+        /* Keep track of app autostart condition in order to react
+         * accordingly in the future. */
+        g_signal_connect (app,
+                          "condition-changed",
+                          G_CALLBACK (app_condition_changed),
+                          manager);
+
+        if (gsm_app_peek_is_disabled (app)
+            || gsm_app_peek_is_conditionally_disabled (app)) {
                 g_debug ("GsmManager: Skipping disabled app: %s", id);
                 goto out;
         }
@@ -308,6 +759,30 @@ _start_app (const char *id,
         if (!start_app_or_warn (manager, app))
                 goto out;
 
+        if (priv->phase < GSM_MANAGER_PHASE_APPLICATION) {
+                /* Historical note - apparently,
+                 * e.g. gnome-settings-daemon used to "daemonize", and
+                 * so gnome-session assumes process exit means "ok
+                 * we're done".  Of course this is broken, we don't
+                 * even distinguish between exit code 0 versus not-0,
+                 * nor do we have any metadata which tells us a
+                 * process is going to "daemonize" or not (and
+                 * basically nothing should be anyways).
+                 */
+                g_signal_connect (app,
+                                  "exited",
+                                  G_CALLBACK (app_exited),
+                                  manager);
+                g_signal_connect (app,
+                                  "notify::registered",
+                                  G_CALLBACK (app_registered),
+                                  manager);
+                g_signal_connect (app,
+                                  "died",
+                                  G_CALLBACK (app_died),
+                                  manager);
+                priv->pending_apps = g_slist_prepend (priv->pending_apps, app);
+        }
  out:
         return FALSE;
 }
@@ -315,11 +790,21 @@ _start_app (const char *id,
 static void
 do_phase_startup (GsmManager *manager)
 {
-        gsm_store_foreach (manager->apps,
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
+        gsm_store_foreach (priv->apps,
                            (GsmStoreFunc)_start_app,
                            manager);
 
-        end_phase (manager);
+        if (priv->pending_apps != NULL) {
+                if (priv->phase < GSM_MANAGER_PHASE_APPLICATION) {
+                        priv->phase_timeout_id = g_timeout_add_seconds (GSM_MANAGER_PHASE_TIMEOUT,
+                                                                                 (GSourceFunc)on_phase_timeout,
+                                                                                 manager);
+                }
+        } else {
+                end_phase (manager);
+        }
 }
 
 typedef struct {
@@ -329,10 +814,10 @@ typedef struct {
 
 
 static gboolean
-_client_end_session (const char           *id,
-                     GsmClient            *client,
+_client_end_session (GsmClient            *client,
                      ClientEndSessionData *data)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (data->manager);
         gboolean ret;
         GError  *error;
 
@@ -348,18 +833,27 @@ _client_end_session (const char           *id,
                 /* FIXME: what should we do if we can't communicate with client? */
         } else {
                 g_debug ("GsmManager: adding client to end-session clients: %s", gsm_client_peek_id (client));
-                data->manager->query_clients = g_slist_prepend (data->manager->query_clients, client);
+                priv->query_clients = g_slist_prepend (priv->query_clients, client);
         }
 
         return FALSE;
 }
 
+static gboolean
+_client_end_session_helper (const char           *id,
+                            GsmClient            *client,
+                            ClientEndSessionData *data)
+{
+        return _client_end_session (client, data);
+}
+
 static void
 complete_end_session_tasks (GsmManager *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
         GSList *l;
 
-        for (l = manager->pending_end_session_tasks;
+        for (l = priv->pending_end_session_tasks;
              l != NULL;
              l = l->next) {
                 GTask *task = G_TASK (l->data);
